/* netplay -- very simple program to play samples from an RTcmix process
   running elsewhere on the network.  This expects short samples, SR = 44.1k,
   2 channels at present; internal buffers are 8k samps.

   Start this program up first.  Then start the RTcmix instrument
   with the "-r <hostname>" flag set ("r" for "remote"), where <hostname>
   is the IP name of the machine running this program.  This will accept
   a connection from the remote machine on socket # 9999 and will start
   trying to grab samples, playing them through the default output device.

   Be sure to shut down the RTcmix process before terminating this one
   or you will have to wait for a minute or two for the network tables
   to flush before restarting this program.  There's probably a way to
   be sure this doesn't happen, but I'm old and tired.

   BGG
*/

/* added command line arg for socket to listen on - 6/22/00 MH
ported to Linux 12/10/00 MH
to MacOSX 5/02 MH
*/


#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
//#include <sys/prctl.h>
#include <errno.h>
#include <byte_routines.h>
#include <sndlibsupport.h>
#include <audio_port.h>
//#include <globals.h> mara added 12/10/00

// pre osx #define BUFSIZE 8192 
#define BUFSIZE 8192
#define BUF_FRAMES          1024 * 2 // open_ports uses, from cmixplay
//#define BUF_FRAMES          1024 * 1 // open_ports uses, from cmixplay
//#define BUF_FRAMES	8192  just as bad as before, changes audio buffer size
//#define BUF_FRAMES	2
#define NUM_ZERO_BUFS       8

int sockno;

#define VERBOSE             1       /* if true, print buffer size */

// MAC OSX:
int play_audio = 1;
typedef float *BufPtr;
BufPtr audioin_buffer[1];
BufPtr out_buffer[1];


main(argc,argv)
int argc;
char *argv[];
{
	int i;
	/* socket stuff */
	int s, ns;
	struct sockaddr_in sss;
	int err,amt,len;
	int child_id;
	int result;
  	 AudioDeviceID out_port; // OSX


	/* audio stuff for RTCMIX2.0 and SGI */
	short sampbuf[BUFSIZE],*sbuf;
//	ALport out_port;
//	ALconfig out_port_config;
//	char *outputPort = NULL;
//	int ports[2]; // 2 = MAXCHANS?
	int buf_frames, fragments;
	long pvbuf[2],buflen;
	int srate;
	int NCHANS;
	char hdr[54];

/* store socket num */
	if ( argc > 1 ) 
		sockno = atoi(*++argv);
	else 
		sockno = 9999;
		
/* configure and open output audio port */
	srate = 44100;
	NCHANS = 2;
               		printf("what is going on");

// open audio port	

	buf_frames = BUF_FRAMES;  	
   	fragments = 2; 
//   	fragments = 10; // linux
/*
	result = open_ports(0, 0, NULL, 2, 2, ports, VERBOSE,
                                      srate, fragments, &buf_frames);
 */
printf("before srate %d fragments %d buf_frames %d\n", srate, fragments, buf_frames);

       result = open_macosx_ports(0, 2, NULL, &out_port, VERBOSE,
                                      (float)srate, fragments, &buf_frames);

printf("after srate %d fragments %d buf_frames %d\n", srate, fragments, buf_frames);

   	if (result == -1) {
   		perror("open port");
      		exit(1);
     	}

/* create the socket for listening */
	if( (s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("socket");
		exit(1);
	}

	/* set up the socket address */
	bzero(&sss, sizeof(sss));
	sss.sin_family = AF_INET;
	sss.sin_addr.s_addr = INADDR_ANY;
	sss.sin_port = htons(sockno);

	if( err = bind(s, (struct sockaddr *)&sss, sizeof(sss)) < 0) {
		perror("bind");
		exit(1);
	}

	/* listen for connections and accept when received */
	/* note: put this into a loop with new socket fdescs and forks for
	   multiple connections */
	
	while (1 ) {

		listen(s, 1);

		len = sizeof(sss);
		ns = accept(s, (struct sockaddr *)&sss, &len);
		if(ns < 0) {
			perror("accept");
			exit(1);
		}
		printf("connection received.\n");
	
 /*  	for (i = 0; i < NUM_ZERO_BUFS; i++) {   // write zeroes
   		write(ports[0], &sampbuf[0], 2);
   	}
*/
		read(ns, (void *)hdr, 17256);  /* throw away header */
			/* sui.5.aiff data_location 54 */
			/* aiff 872 au 792 */

		while(1) {
               		printf("while loop");

			// zero out sampbuf
			for( i = 0 ; i < BUFSIZE; i++ )
				sampbuf[i] = 0;

			/* read a buffer from the socket */
			amt = read(ns, (void *)sampbuf, sizeof(sampbuf));
			if ( amt != 8192)
                		fprintf(stderr,"%d ",amt);

			while (amt < sizeof(sampbuf)) 
				amt += read(ns, (void *)sampbuf, sizeof(sampbuf)-amt);
			
		
			printf("sampbuf 0-2: %d %d %d\n",sampbuf[0],sampbuf[1],sampbuf[2]);
/*
		
 			// swap the bytes from SGI big endian to Linux little endian
 			// and write to audio port
 			for ( i = 0; i < BUFSIZE; i++ ) {
  				sampbuf[i] = reverse_int2(&sampbuf[i]);
  				if (!(write(ports[0], &sampbuf[i], 2))) {
 					fprintf(stderr, "bad write to audio convertor\n");
					return -1;
				}
			}
*/
			macosx_cmixplay_audio_write(sampbuf);
 				
 		  		
		}

		for (i = 0; i < BUFSIZE; i++)
			sampbuf[i] = 0;
		macosx_cmixplay_audio_write(sampbuf);

/*
		sampbuf[0] = 0;   // write zeroes to prevent clicks
   		for (i = 0; i < NUM_ZERO_BUFS; i++) {
   			write(ports[0], &sampbuf[0], 2);
   		}
	
		// close audio port
   		close(ports[0]);
*/

	}

}


